using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Autoscribe.Lyons.AOAServiceContract;
using Autoscribe.Lyons.GeneralService;

namespace atmDemo.Wrapper
{
    interface IAoaServiceWrapper
    {
        LogonResult Logon(int companyId, string username, string password);
        void Logoff(string token);
       
        StatusDescriptionResult DescribeStatusCode(string token, int statusCode);
        DetailedStatusCodeResult CheckAccountOwnershipAndStatus(string token, string returnDetails, string rtn, string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
        DetailedStatusCodeResult CheckAccountOwnership(string token, string returnDetails, string rtn, string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
        DetailedStatusCodeResult CheckAccountStatus(string token, string returnDetails, string rtn, string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
        DetailedStatusCodeResultWithDates CheckAccountOwnershipAndStatusWithDates(string token, string returnDetails, string rtn,
          string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
        DetailedStatusCodeResultWithDates CheckAccountOwnershipWithDates(string token, string returnDetails, string rtn, string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
        DetailedStatusCodeResultWithDates CheckAccountStatusWithDates(string token, string returnDetails, string rtn, string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);

        DetailedOverallAccountStatusAndOwnershipResults CheckOverallAccountStatusWithOwnersipInfo(string token, string returnDetails, string rtn,
          string account, string amount, string customerPresent, string denyNsf, string country, AccountOwner owner);
    }
}
