using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Autoscribe.Lyons.GeneralService;
using atmDemo.Wrapper;
using System.Configuration;
using Autoscribe.Lyons.AOAServiceContract;

namespace atmDemo
{
    class demoService
    {
        public const string CFG_LOGON_USERNAME = "userName";
        public const string CFG_LOGON_COMPANYID = "companyID";
        public const string CFG_LOGON_PASSWORD = "userPassword";
        // Test Data
        public const string CFG_TEST_RTN = "demoRtn";
        public const string CFG_TEST_ACCOUNT = "demoAccountNo";
        public const string CFG_TEST_AMOUNT = "demoAmount";
        public const string CFG_TEST_PRESENT = "demoPresent";
        public const string CFG_TEST_DENYNSF = "demoDenyNsf";
        public const string CFG_TEST_COUNTRY = "demoCountry";
        public const string CFG_TEST_RETURN_DETAILS = "demoReturnDetails";

        // Account Owner test data
        public const string CfgTestOwnerFirstname = "owner.firstName";
        public const string CfgTestOwnerLastname = "owner.lastName";
        public const string CfgTestOwnerMiddleName = "owner.middleName";
        public const string CfgTestOwnerNamePfx = "owner.namePfx";
        public const string CfgTestOwnerNameSfx = "owner.nameSfx";
        public const string CfgTestOwnerBusinessName = "owner.businessName";
        public const string CfgTestOwnerAddress1 = "owner.address1";
        public const string CfgTestOwnerAddress2 = "owner.address2";
        public const string CfgTestOwnerCity = "owner.city";
        public const string CfgTestOwnerState = "owner.state";
        public const string CfgTestOwnerZip = "owner.zip";
        public const string CfgTestOwnerSsn = "owner.ssn";
        public const string CfgTestOwnerDob = "owner.dob";
        public const string CfgTestOwnerIdType = "owner.idType";
        public const string CfgTestOwnerIdNo = "owner.idNo";
        public const string CfgTestOwnerIdState = "owner.idState";
        private readonly string _firstName;
        private readonly string _lastName;
        private readonly string _middleName;
        private readonly string _namePfx;
        private readonly string _nameSfx;
        private readonly string _businessName;
        private readonly string _address1;
        private readonly string _address2;
        private readonly string _city;
        private readonly string _state;
        private readonly string _zip;
        private readonly string _ssn;
        private readonly string _dob;
        private readonly string _idType;
        private readonly string _idNo;
        private readonly string _idState;
        // Test Data
        private IAoaServiceWrapper aoaSvc = new AoaServiceWrapper();
        public string GetAppSetting(string key)
        {
            string res = null;
            try
            {
                res = ConfigurationManager.AppSettings.Get(key);
            }
            catch { }
            return res;
        }

        public demoService()
        {
            _firstName    = GetAppSetting(CfgTestOwnerFirstname);
            _lastName     = GetAppSetting(CfgTestOwnerLastname);
            _middleName   = GetAppSetting(CfgTestOwnerMiddleName);
            _namePfx      = GetAppSetting(CfgTestOwnerNamePfx);
            _nameSfx      = GetAppSetting(CfgTestOwnerNameSfx);
            _businessName = GetAppSetting(CfgTestOwnerBusinessName);
            _address1     = GetAppSetting(CfgTestOwnerAddress1);
            _address2     = GetAppSetting(CfgTestOwnerAddress2);
            _city         = GetAppSetting(CfgTestOwnerCity);
            _state        = GetAppSetting(CfgTestOwnerState);
            _zip          = GetAppSetting(CfgTestOwnerZip);
            _ssn          = GetAppSetting(CfgTestOwnerSsn);
            _dob          = GetAppSetting(CfgTestOwnerDob);
            _idType       = GetAppSetting(CfgTestOwnerIdType);
            _idNo         = GetAppSetting(CfgTestOwnerIdNo);
            _idState      = GetAppSetting(CfgTestOwnerIdState);
        }
        public bool GetFullStatusReport()
        {
            bool status = false;
           
            try
            {
                string userName = GetAppSetting(CFG_LOGON_USERNAME);
                string password = GetAppSetting(CFG_LOGON_PASSWORD);
                int companyId = Int32.Parse(GetAppSetting(CFG_LOGON_COMPANYID));
                string rtn = GetAppSetting(CFG_TEST_RTN);
                string account = GetAppSetting(CFG_TEST_ACCOUNT);
                string amount = GetAppSetting(CFG_TEST_AMOUNT);
                string present = GetAppSetting(CFG_TEST_PRESENT);
                string denyNsf = GetAppSetting(CFG_TEST_DENYNSF);
                string returnDetails = GetAppSetting(CFG_TEST_RETURN_DETAILS);
                string country = GetAppSetting(CFG_TEST_COUNTRY);

                string token = aoaSvc.Logon(companyId, userName, password).Token;


                // CheckAccountStatus Account
                StatusCodeResult checkAccountStatusTest = aoaSvc.CheckAccountStatus(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());
                if (checkAccountStatusTest != null && checkAccountStatusTest.ErrorMesssage == null)
                {
                    
                    Console.WriteLine(
                        $"CheckAccountStatus: (returnDetails: {returnDetails}, rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, country:{country}) status code {checkAccountStatusTest.StatusCode}");
                }
                    
                else
                    Console.WriteLine($"CheckAccountStatus: {rtn} has an error {checkAccountStatusTest?.ErrorMesssage}");

                // Describe Status Code
                if (checkAccountStatusTest != null)
                {
                    StatusDescriptionResult describeStatusCodeTest = aoaSvc.DescribeStatusCode(token, checkAccountStatusTest.StatusCode);
                    if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                        Console.WriteLine(
                            $"DescribeStatusCode: (statusCode:{describeStatusCodeTest.StatusCode}) description: {describeStatusCodeTest.StatusDescription}");
                    else
                        Console.WriteLine($"DescribeStatusCode: {rtn} has an error {describeStatusCodeTest?.ErrorMesssage}");
                }

                // CheckAccountOwnershipAndStatus
                DetailedStatusCodeResult combinedStatusTest = aoaSvc.CheckAccountOwnershipAndStatus(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());
                var ownerName = string.IsNullOrWhiteSpace(_firstName) || string.IsNullOrWhiteSpace(_lastName)
                    ? _businessName
                    : _firstName + _lastName;

                if (combinedStatusTest != null && combinedStatusTest.ErrorMesssage == null)
                    Console.WriteLine(
                        $"CheckAccountOwnershipAndStatus: (rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, denyNsf:{denyNsf}, name: {ownerName}) {combinedStatusTest.PrimaryInstitution.Name} | {combinedStatusTest.PrimaryInstitution.State}");
                else
                    Console.WriteLine(
                        $"CheckAccountOwnershipAndStatus: {rtn} has an error {combinedStatusTest?.ErrorMesssage}");

                // CheckOverallAccountStatusWithOwnersipInfo
                DetailedOverallAccountStatusAndOwnershipResults overallCombinedStatusWithAccountStatus = aoaSvc.CheckOverallAccountStatusWithOwnersipInfo(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());

                if (overallCombinedStatusWithAccountStatus != null && overallCombinedStatusWithAccountStatus.ErrorMesssage == null)
                    Console.WriteLine(
                        $"CheckOverallAccountStatusWithOwnersipInfo: (rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, denyNsf:{denyNsf}, name: {ownerName}) with response Institution name {overallCombinedStatusWithAccountStatus.PrimaryInstitution.Name} | institution state name {overallCombinedStatusWithAccountStatus.PrimaryInstitution.State} |StatusCode: {overallCombinedStatusWithAccountStatus.StatusCode} |OwnershipStatusCode: {overallCombinedStatusWithAccountStatus.OwnershipStatusCode} |OverallStatusCode: {overallCombinedStatusWithAccountStatus.OverallStatusCode} | BusinessFullMatch: {overallCombinedStatusWithAccountStatus.BusinessOrFullNameMatch}| FirstNameMatch:{overallCombinedStatusWithAccountStatus.FirstNameMatch}| LatNameMatch {overallCombinedStatusWithAccountStatus.LastNameMatch} | cityMatch {overallCombinedStatusWithAccountStatus.CityMatch} | stateMatch {overallCombinedStatusWithAccountStatus.StateMatch } | zipmatch {overallCombinedStatusWithAccountStatus.ZipMatch} | ssnOrDobMatch {overallCombinedStatusWithAccountStatus.SsnMatch} | dobMatch {overallCombinedStatusWithAccountStatus.DobMatch}  | idMatch {overallCombinedStatusWithAccountStatus.IdMatch} | lastUpdate {overallCombinedStatusWithAccountStatus.LastUpdate} | addClosedDate {overallCombinedStatusWithAccountStatus.AddClosedDate}");
                else
                    Console.WriteLine(
                        $"CheckOverallAccountStatusWithOwnersipInfo: {rtn} has an error {overallCombinedStatusWithAccountStatus?.ErrorMesssage}");



                // Describe Status Code
                if (combinedStatusTest != null)
                {
                    StatusDescriptionResult describeStatusCodeTest = aoaSvc.DescribeStatusCode(token, combinedStatusTest.StatusCode);
                    if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                        Console.WriteLine(
                            $"DescribeStatusCode: (statusCode:{describeStatusCodeTest.StatusCode}) description: {describeStatusCodeTest.StatusDescription}");
                    else
                        Console.WriteLine($"DescribeStatusCode: {rtn} has an error {describeStatusCodeTest?.ErrorMesssage}");
                }

                // CheckAccountOwnership
                DetailedStatusCodeResult checkAccountOwnershipTest = aoaSvc.CheckAccountOwnership(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());

                if (checkAccountOwnershipTest != null && checkAccountOwnershipTest.ErrorMesssage == null)
                    Console.WriteLine(
                        $"CheckAccountOwnership: (rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, denyNsf:{denyNsf}, , name: {ownerName}) {checkAccountOwnershipTest.PrimaryInstitution.Name} | {checkAccountOwnershipTest.PrimaryInstitution.State}");
                else
                    Console.WriteLine(
                        $"CheckAccountOwnership: {rtn} has an error {checkAccountOwnershipTest?.ErrorMesssage}");



                // Describe Status Code
                if (checkAccountOwnershipTest != null)
                {
                    StatusDescriptionResult describeStatusCodeTest = aoaSvc.DescribeStatusCode(token, checkAccountOwnershipTest.StatusCode);
                    if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                        Console.WriteLine(
                            $"DescribeStatusCode: (statusCode:{describeStatusCodeTest.StatusCode}) description: {describeStatusCodeTest.StatusDescription}");
                    else
                        Console.WriteLine($"DescribeStatusCode: {rtn} has an error {describeStatusCodeTest?.ErrorMesssage}");
                }

                // CheckAccountStatusWithDates for given Account
                DetailedStatusCodeResultWithDates checkAccountStatusWithDatesTest = aoaSvc.CheckAccountStatusWithDates(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());
                if (checkAccountStatusWithDatesTest != null && checkAccountStatusTest.ErrorMesssage == null)
                {

                    Console.WriteLine(
                        $"CheckAccountStatusWithDates: (returnDetails: {returnDetails}, rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, country:{country}) status code {checkAccountStatusWithDatesTest.StatusCode}  Account last updated Date {checkAccountStatusWithDatesTest.LastUpdate} and Account Add closed date {checkAccountStatusWithDatesTest.AddClosedDate}");
                }

                else
                    Console.WriteLine($"CheckAccountStatusWithDates: {rtn} has an error {checkAccountStatusWithDatesTest?.ErrorMesssage}");

             
                // CheckAccountOwnershipAndStatus
                DetailedStatusCodeResultWithDates combinedStatusWithDatesTest = aoaSvc.CheckAccountOwnershipAndStatusWithDates(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());
                var ownerName1 = string.IsNullOrWhiteSpace(_firstName) || string.IsNullOrWhiteSpace(_lastName)
                    ? _businessName
                    : _firstName + _lastName;

                if (combinedStatusWithDatesTest != null && combinedStatusWithDatesTest.ErrorMesssage == null)
                    Console.WriteLine(
                        $"CheckAccountOwnershipAndStatusWithDates: (rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, denyNsf:{denyNsf}, name: {ownerName}) {combinedStatusWithDatesTest.StatusCode}| {combinedStatusWithDatesTest.LastUpdate} | {combinedStatusWithDatesTest.AddClosedDate} |{combinedStatusWithDatesTest.PrimaryInstitution.Name} | {combinedStatusWithDatesTest.PrimaryInstitution.State}");
                else
                    Console.WriteLine(
                        $"CheckAccountOwnershipAndStatusWithDates: {rtn} has an error {combinedStatusWithDatesTest?.ErrorMesssage}");



                // Describe Status Code
                if (combinedStatusWithDatesTest != null)
                {
                    StatusDescriptionResult describeStatusCodeTest = aoaSvc.DescribeStatusCode(token, combinedStatusWithDatesTest.StatusCode);
                    if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                        Console.WriteLine(
                            $"DescribeStatusCode: (statusCode:{describeStatusCodeTest.StatusCode}) description: {describeStatusCodeTest.StatusDescription}");
                    else
                        Console.WriteLine($"DescribeStatusCode: {rtn} has an error {describeStatusCodeTest?.ErrorMesssage}");
                }

                // CheckAccountOwnership
                DetailedStatusCodeResultWithDates checkAccountOwnershipWithDatesTest = aoaSvc.CheckAccountOwnershipWithDates(token, returnDetails, rtn, account, amount, present, denyNsf, country, PrepareAccountOwner());

                if (checkAccountOwnershipWithDatesTest != null && checkAccountOwnershipWithDatesTest.ErrorMesssage == null)
                    Console.WriteLine(
                        $"CheckAccountOwnershipWithDates: (rtn: {rtn}, account: {account}, amount:{amount}, present:{present}, denyNsf:{denyNsf}, , name: {ownerName}){combinedStatusWithDatesTest.StatusCode}| {combinedStatusWithDatesTest.LastUpdate} | {combinedStatusWithDatesTest.AddClosedDate} | {checkAccountOwnershipTest.PrimaryInstitution.Name} | {checkAccountOwnershipTest.PrimaryInstitution.State}");
                else
                    Console.WriteLine(
                        $"CheckAccountOwnershipWithDates: {rtn} has an error {checkAccountOwnershipTest?.ErrorMesssage}");



                // Describe Status Code
                if (checkAccountOwnershipWithDatesTest != null)
                {
                    StatusDescriptionResult describeStatusCodeTest = aoaSvc.DescribeStatusCode(token, checkAccountOwnershipWithDatesTest.StatusCode);
                    if (describeStatusCodeTest != null && describeStatusCodeTest.ErrorMesssage == null)
                        Console.WriteLine(
                            $"DescribeStatusCode: (statusCode:{describeStatusCodeTest.StatusCode}) description: {describeStatusCodeTest.StatusDescription}");
                    else
                        Console.WriteLine($"DescribeStatusCode: {rtn} has an error {describeStatusCodeTest?.ErrorMesssage}");
                }


                aoaSvc.Logoff(token);
                return true;
            }
            catch(Exception ex)
            {
                Console.WriteLine("error:input parameters are not in correct format, Please check the app.config and add missing required parameters.");
            }
            return false;
        }


        private AccountOwner PrepareAccountOwner()
        {
            var accountOwner = new AccountOwner()
            {
                Address1 = _address1,
                Address2 = _address2,
                BusinessName = _businessName,
                City= _city,
                DateOfBirth = _dob,
                FirstName = _firstName,
                IdNo = _idNo,
                IdState = _idState,
                IdType = _idType,
                LastName = _lastName,
                MiddleName = _middleName,
                NamePrefix = _namePfx,
                NameSuffix = _nameSfx,
                State = _state,
                ZipCode = _zip,
                Ssn = _ssn
            };
            return accountOwner;
        }
    }
}
